function [Data,Proto]=GenerateData(Centers,Dispersions,NumbersOfData);

% ----------------------------------------------------------------
% Sistemi intelligenti - A.A. 2004/ 2005
% Esercitazione del 3/12/2004
% 
% Generatore dati per KMeans.
%
% ----------------------------------------------------------------

% Numero totale e dimensione dei dati
NData=sum(NumbersOfData);
M=size(Centers,2);
NumberOfCluster=size(Centers,1);

% Inizializzazione dati
Data=[];
for ClusterIndex=1:NumberOfCluster
    
    % Inizializzazione dati dei cluster
    DataOfCluster=repmat(Centers(ClusterIndex,:),NumbersOfData(ClusterIndex),1);
    
    % Dispersione dei dati
    DataOfCluster=DataOfCluster+Dispersions(ClusterIndex)*randn(NumbersOfData(ClusterIndex),M);
    
    % Append dei dati
    Data=[Data; DataOfCluster];
    
end

% Inizializzazione prototipi
Proto=Centers;
Proto=Centers+5*mean(Dispersions)*randn(NumberOfCluster,M);

% Permutazione casuale dati
Data=Data(randperm(NData),:);

% Plot time
if M==2
    plot(Data(:,1),Data(:,2),'b.',Proto(:,1),Proto(:,2),'r.');
end