function [KProto,Class]=KMeans(Data,Proto,MaxNIter);

% ----------------------------------------------------------------
% Sistemi intelligenti - A.A. 2004/ 2005
% Esercitazione del 3/12/2004
% 
% KMeans.
%
% ----------------------------------------------------------------

% Numero e dimensione dei dati
NData=length(Data(:,1));
M=length(Data(1,:));

% Numero dei prototipi
NProto=length(Proto(:,1));

% Matrice di classficazione
Class=zeros(NData,1);

% Iterazioni per l'addestramento
NIter=0;
while (NIter<MaxNIter)
    
    % Iterazione
    NIter=NIter+1;
    
    % Costruisce la matrice delle distanze per la classificazione
    D=zeros(NData,M);
    for DataIndex=1:NData
        for ProtIndex=1:NProto
            D(DataIndex,ProtIndex)=norm(Data(DataIndex,:)-Proto(ProtIndex,:));
        end
    end
    
    % Classifica i prototipi
    for DataIndex=1:NData
        
        % Cluster a distanza minima (p-esimo prototipo)
        [m,p]=min(D(DataIndex,:));
        p=p(1);
        Class(DataIndex)=p;
                    
    end
    
    % Plot time
    if (M==2)
        figure(1);
        subplot (10,1,1:7);
        plot (Data(:,1),Data(:,2),'b.');
        hold on;
        plot (Proto(:,1),Proto(:,2),'r.','MarkerSize',20);
        for DataIndex=1:NData
            plot ([Data(DataIndex,1) Proto(Class(DataIndex),1)],[Data(DataIndex,2) Proto(Class(DataIndex),2)],'k');
        end
        hold off;
        title(['Iter = ' num2str(NIter)]);
        pause;
    end
    
    % Calcola le nuove posizioni dei prototipi
    for ProtoIndex=1:NProto
        
        % Trova gli indici di tutti i dati classificati dal prototipo
        ProtoDataIndex=find(Class==ProtoIndex);
        
        % Aggiorna il prototipo
        if ~isempty(ProtoDataIndex)
            Proto(ProtoIndex,:)=mean(Data(ProtoDataIndex,:));
        end
        
    end
    
    % Calcola la distanza media di ogni punto dal prototipo che lo
    % classifica
    MeanResidual(NIter)=0;
    for DataIndex=1:NData
        MeanResidual(NIter)=MeanResidual(NIter)+D(DataIndex,Class(DataIndex));
    end
    MeanResidual(NIter)=MeanResidual(NIter)/NData;
    
    % Disply prot
    disp([' ']);
    disp(['Iter = ' num2str(NIter) ' Mean Res = ' num2str(MeanResidual(NIter))]);
    for ProtoIndex=1:NProto
        disp(['Prot ' num2str(ProtoIndex) ' = ' num2str(Proto(ProtoIndex,:))]);
    end
    
    % Plot time
    if (M==2)
        figure(1);
        subplot (10,1,1:7);
        plot (Data(:,1),Data(:,2),'b.');
        hold on;
        plot (Proto(:,1),Proto(:,2),'r.','MarkerSize',20);
        hold off;
        title(['Iter = ' num2str(NIter)]);
        subplot (10,1,8:10);
        plot (1:NIter,MeanResidual(1:NIter));
        xlabel('Iter');
        ylabel('Mean Res');
        pause;
    end
    
end

% Plot time
if (M==2)
    figure;
    plot (Data(:,1),Data(:,2),'b.');
    hold on;
    plot (Proto(:,1),Proto(:,2),'r.','MarkerSize',20);
    for DataIndex=1:NData
        plot ([Data(DataIndex,1) Proto(Class(DataIndex),1)],[Data(DataIndex,2) Proto(Class(DataIndex),2)],'k');
    end
    hold off;
    title('Final classification');
    pause;
end

% Output
KProto=Proto;
