function [Features]=ComputeImageFeatures(Image);

% Accetta solo immagini uint8
if ~isa(Image,'uint8')
    disp('Not uint8 image!');
    return;
end

% Ridimensiona l'immagine
NRow=30;
NCol=20;
Imagef=imresize(Image,[NRow NCol]);

% Equalizza l'immagine
Imagef=histeq(Imagef);

% Binarizza l'immagine
Imagef=Imagef>127;

% Features: posizione baricentro, momento d'inerzia rispetto all'asse x e
% all'asse y
m1=mean(mean(Imagef(1:10,1:10)))+0.1;
m2=mean(mean(Imagef(11:20,1:10)))+0.1;
m3=mean(mean(Imagef(21:30,1:10)))+0.1;
m4=mean(mean(Imagef(1:10,11:20)))+0.1;
m5=mean(mean(Imagef(11:20,11:20)))+0.1;
m6=mean(mean(Imagef(21:30,11:20)))+0.1;

% Posizione baricentro
B=[0 0];
for Row=1:NRow
    for Col=1:NCol
        B(1)=B(1)+Row*Imagef(Row,Col);
        B(2)=B(2)+Col*Imagef(Row,Col);
    end
end
B=B/sum(Imagef(:));

% Momenti d'inerzia
J=[0 0];
for Row=1:NRow
    for Col=1:NCol
        J(1)=J(1)+((Row-B(1))^2)*Imagef(Row,Col);
        J(2)=J(2)+((Col-B(2))^2)*Imagef(Row,Col);
    end
end
J=J/sum(Imagef(:));

% Calcola le proiezioni per il riconoscimento
H=mean(Imagef);
V=mean(Imagef');

%Features=[m1 m2 m3 m4 m5 m6]';
%Features=[J m1 m2 m3 m4 m5 m6]';
%Features=[B J]';
%Features=[H V]';
Features=[m1 m2 m3 m4 m5 m6 m1-m2 m2-m3 m1-m4 m2-m5 m3-m6]';