function [SOM]=Create1xNSOM(N,M);

% [SOM]=Create1xNSOM(N,M);
% Crea una SOM da addestrare con il Boundary First Method; la dimensione
% dello spazio dei dati  M.

% Dimensioni della SOM
SOM.NumberOfRows=1;
SOM.NumberOfColumns=N;

% Inizializzazione spazio topologico SOM
SOM.TopologicalPositions=zeros(SOM.NumberOfRows*SOM.NumberOfColumns,2);
Index=0;
for Row=1:SOM.NumberOfRows
    for Col=1:SOM.NumberOfColumns
        Index=Index+1;
        SOM.TopologicalPositions(Index,:)=[Row Col];
    end
end

% Creazione matrice LUT per il calcolo delle distanze con basso impiego di
% RAM
SOM.TopologicalDistancesLUT=CreateTopologicalDistancesLUT(SOM.NumberOfRows,SOM.NumberOfColumns);

% Inizializzazione pesi dei neuroni
SOM.Weights=randn(SOM.NumberOfRows*SOM.NumberOfColumns,M);

% Altri parametri
SOM.OrderPhaseLearningRate=NaN;
SOM.TunePhaseLearningRate=NaN;
SOM.TuningPhaseNeighborhoodDistance=NaN;
SOM.Epochs=NaN;