function [SOM]=SOMTest;

% ----------------------------------------------------------------
% Sistemi intelligenti - A.A. 2004/ 2005
% Esercitazione del 3/12/2004
% 
% Test utilizzo SOM 1D per riconoscimento ed ordinamento dei caratteri
% Braille.
%
% ----------------------------------------------------------------

% Lista delle tif in directory
D=dir('*.tif');
N=length(D); % (N=26)

% Training dataset
X=[];

% Lettura
for n=1:N
    
    % Nome del file
    FileName=getfield(D,{n,1},'name');
    Image=imread(FileName);
    
    % Calcola le features
    Features=ComputeImageFeatures(Image);
    
    % Costruisce la matrice di addestramento per la SOM
    X=[X Features];
        
end

% Ampliamento dataset
X=repmat(X,1,200);
X=X+0.01*randn(size(X));

% Creazione SOM
SOM=Create1xNSOM(N,size(X,1));

% Addestramento SOM
[SOM]=TrainSOM(SOM,0.2,0.1,0.05,30,X');

% Immagine con il braille ordinato
Braille=zeros(10,N*10);

% Ordinamento lettere nello spazio della SOM
for n=1:N
    
    % Nome del file
    FileName=getfield(D,{n,1},'name');
    Image=imread(FileName);
    
    % Calcola le features
    Features=ComputeImageFeatures(Image);
    
    % Testa la SOM
    Winner=SimulateSOM(SOM.Weights,Features')
    
    % Coordinate sull'immagine
    V0=(Winner-1)*10+1;
    
    % Immagine
    if (mean(mean(Braille(1:10,V0:V0+9)))==0)
        Braille(1:10,V0:V0+9)=[double(imresize(Image,[10 9])) NaN*ones(10,1)];
    else
        NRow=size(Braille,1);
        Braille(NRow+1:NRow+10,V0:V0+9)=[double(imresize(Image,[10 9])) NaN*ones(10,1)];
    end
       
    % Plot time
    imagesc(Braille);
    axis equal;
    axis off;
    colormap gray;
    pause;
    
end

