function [Weights]=single_train_SOM2D(Weights,NumberOfRows,NumberOfColumns,TopologicalPositions,TopologicalDistancesLUT,LearningRate,NeighborhoodDistance,InputPoint);

% Singolo addestramento per la SOM

% trovo il neurone vincente
Winner=SimulateSOM(Weights,InputPoint);

% Se  un neurone di bordo, raddoppia learning rate e neighborhood distance
if (TopologicalPositions(Winner,1)==1)|(TopologicalPositions(Winner,2)==1)|...
   (TopologicalPositions(Winner,1)==NumberOfRows)|(TopologicalPositions(Winner,2)==NumberOfColumns)
        LearningRate=LearningRate*1.3;
        NeighborhoodDistance=NeighborhoodDistance*1.3;
end

% Costanti
One_sqrt2pi=1/sqrt(2*pi);

% Posizione topologica del neurone vincente
[RowWinner]=TopologicalPositions(Winner,1);
[ColWinner]=TopologicalPositions(Winner,2);

% Aggiornamento neuroni
for Index=1:length(Weights(:,1))
    
    % Posizione neurone da aggiornare
    [Row]=TopologicalPositions(Index,1);
    [Col]=TopologicalPositions(Index,2);
    
    % Distanza neurone vincente / neurone da aggiornare
    Distance=TopologicalDistancesLUT(abs(RowWinner-Row)+1,abs(ColWinner-Col)+1);
    
     if (Distance<(5*NeighborhoodDistance))
         
         % Aggionramento pesi
         Weights(Index,:)=Weights(Index,:)+...
                          (LearningRate*(InputPoint-Weights(Index,:)))*...
                          exp(-((Distance^2)/(2*(NeighborhoodDistance^2))));
    end    
end